/* --------------------------------------------------------------
          ( 2.2).
       .

    http://www.imach.uran.ru/cbignum

    Copyright 1999-2024, ..,   PAH.
    All Rights Reserved.

         "public domain",
    ..   ,  
         
          .

        " "
     - ,   . 
           . 
          , ,
            
       .
-------------------------------------------------------------- */
#ifndef _CBIGNUMF_H
#define _CBIGNUMF_H
#include "Cbnl.h"

//================================================
//        .
//================================================
//      _CBIGNUM_ASM              Cbignumf.cpp

#ifndef _CBIGNUMF_INL
#if 1
#define _CBIGNUM_ASM
#endif
#endif//_CBIGNUMF_INL

//================================================
//        .
//================================================
//      _CBIGNUM_HARDWARE_CBR    // 
//                              /   .
//      _CBIGNUM_HARDWARE_MUL      ,
//                                  
//                                  .
//      _CBIGNUM_HARDWARE_DIV      ( 
//                                divd/modd)  .

#ifdef  _CBIGNUM_ASM

#ifdef  _CBNL_CBR
#if 1
#define _CBIGNUM_HARDWARE_CBR
#endif
#endif//_CBNL_CBR

#endif//_CBIGNUM_ASM

#ifdef  _CBNL_MUL
#if 1
#define _CBIGNUM_HARDWARE_MUL
#endif
#endif//_CBNL_MUL

#if 1
#define _CBIGNUM_HARDWARE_DIV
#endif

//================================================
//        .
//================================================
//      _CBIGNUM_KARATSUBA_MUL    , 
//                                  _CBNL_KARATSUBA_MIN
//                                .
//
//      _CBIGNUM_BLOCK_MUL        , 
//                                  _CBNL_TAB_HIGH
//                                 (  
//                                L1,   
//                                 ,
//                               ,    
//                               _CBNL_KARATSUBA_MIN ).
//
//      _CBIGNUM_TERNARY_MUL       30% 
//                                   
//                                  (
//                                  
//                               ,   ).
//
//      _CBIGNUM_SHIFTTAB_MUL       
//                              ,     
//                              _CBNL_TAB_MIN    ( 
//                                 
//                              ,   ).
//
//      _CBIGNUM_SHIFTTAB_DIV       
//                                ,   
//                                _CBNL_TAB_MIN  
//                                   
//                              _CBNL_TAB_MAX  ( 
//                                _CBIGNUM_SUBMUL_DIV).
//
//      _CBIGNUM_SUBMUL_DIV        
//                                 ,   ,
//                                   .
//
//      _CBIGNUM_SMALL_DIV         
//                                 ,  
//                                 1  2.
//
//      _CBIGNUM_SMALL_POWMOD      
//                                   ,
//                                 .
//
//      _CBIGNUM_REVERSE_MOD        
//                                 .
//                                .
//
//      _CBIGNUM_REDUCE_JUMPS     
//                                  .
//                                 .

#if 1
#define _CBIGNUM_KARATSUBA_MUL
#endif

#if 1
#define _CBIGNUM_BLOCK_MUL
#endif

#if 1
#define _CBIGNUM_TERNARY_MUL
#endif

#if 1
#define _CBIGNUM_SHIFTTAB_MUL
#endif

#if 1
#define _CBIGNUM_SHIFTTAB_DIV
#endif

#ifdef  _CBIGNUM_HARDWARE_MUL
#ifdef  _CBIGNUM_HARDWARE_DIV
#ifdef  _CBNL_DIV
#if 1
#define _CBIGNUM_SUBMUL_DIV
#endif
#endif//_CBNL_DIV
#endif//_CBIGNUM_HARDWARE_DIV
#endif//_CBIGNUM_HARDWARE_MUL

#ifndef _CBIGNUM_SUBMUL_DIV
#if 1
#define _CBIGNUM_SMALL_DIV 2
#endif
#endif//_CBIGNUM_SUBMUL_DIV

#if 1
#define _CBIGNUM_SMALL_POWMOD
#endif

#if 0
#define _CBIGNUM_REVERSE_MOD
#endif

#if 0
#define _CBIGNUM_REDUCE_JUMPS
#endif

//================================================
//        .
//================================================
//           
//          :
//      _CBIGNUM_HARDWARE_MUL    
//      _CBIGNUM_SUBMUL_DIV      
//
//      _CBNL_TAB_MIN             ,  
//                                  
//                              
//                                  
//                              ,    
//                                .
//
//      _CBNL_TAB_OPT              
//                                  ,
//                                 ;
//                                  8n - 3.
//
//      _CBNL_TAB_HIGH             
//                                  ,
//                                 .
//
//      _CBNL_TAB_FULL            ,  
//                                  
//                                 (
//                               64- Visual C++).
//
//      _CBNL_TAB_MAX             ,  
//                                  .
//
//      _CBNL_KARATSUBA_MIN         
//                                 .
//
//      _CBNL_MUL_OPT              
//                                 ,
//                                 ;
//                                  8n - 3.
//
//      _CBNL_MUL_HIGH             
//                                 ,
//                                 .
//
//           CBNL   .
//
//      _CBNL_HARDDIV_BITS            
//                               ,    
//                              ,   .
//                                  
//                                   
//                              ,    
//                                  
//                               .

#define _CBNL_TAB_MIN   (3)
#define _CBNL_TAB_OPT   (((sizeof(size_t)<=2)? 120: 7680)/\
                         (sizeof (CBNL) * sizeof (CBNL)) - 3)
#define _CBNL_TAB_HIGH  (_CBNL_TAB_OPT + _CBNL_TAB_OPT / 2)
#if 0
#ifndef _CBIGNUM_SUBMUL_DIV
#ifdef  _MSC_VER
#ifdef  _WIN64
#define _CBNL_TAB_FULL  (64000/(sizeof (CBNL) * sizeof (CBNL)))
#endif//_WIN64
#endif//_MSC_VER
#endif//_CBIGNUM_SUBMUL_DIV
#endif
#define _CBNL_TAB_MAX   ((EXSIZE_T_MAX & (size_t)0x7FFFFFFFUL)/\
                         (1024 * sizeof (CBNL)))

#ifndef _CBIGNUM_HARDWARE_MUL
#define _CBNL_KARATSUBA_MIN     (100)
#else
#define _CBNL_KARATSUBA_MIN     (50)
#define _CBNL_MUL_OPT   (7680 / sizeof (CBNL) - 3)
#define _CBNL_MUL_HIGH  (_CBNL_MUL_OPT + _CBNL_MUL_OPT / 2)
#endif//_CBIGNUM_HARDWARE_MUL

#define _CBNL_HARDDIV_BITS 10

#endif//_CBIGNUMF_H
